<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDCSCoupon ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDCSCoupon
 * @subpackage Arrays
 */
class ArrayOfDCSCoupon extends AbstractStructArrayBase
{
    /**
     * The DCSCoupon
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\DCSCoupon[]
     */
    public $DCSCoupon;
    /**
     * Constructor method for ArrayOfDCSCoupon
     * @uses ArrayOfDCSCoupon::setDCSCoupon()
     * @param \App|C\StructType\DCSCoupon[] $dCSCoupon
     */
    public function __construct(array $dCSCoupon = array())
    {
        $this
            ->setDCSCoupon($dCSCoupon);
    }
    /**
     * Get DCSCoupon value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\DCSCoupon[]|null
     */
    public function getDCSCoupon()
    {
        return isset($this->DCSCoupon) ? $this->DCSCoupon : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDCSCoupon method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDCSCoupon method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDCSCouponForArrayConstraintsFromSetDCSCoupon(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDCSCouponDCSCouponItem) {
            // validation for constraint: itemType
            if (!$arrayOfDCSCouponDCSCouponItem instanceof \App|C\StructType\DCSCoupon) {
                $invalidValues[] = is_object($arrayOfDCSCouponDCSCouponItem) ? get_class($arrayOfDCSCouponDCSCouponItem) : sprintf('%s(%s)', gettype($arrayOfDCSCouponDCSCouponItem), var_export($arrayOfDCSCouponDCSCouponItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DCSCoupon property can only contain items of type \App|C\StructType\DCSCoupon, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DCSCoupon value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\DCSCoupon[] $dCSCoupon
     * @return \App|C\ArrayType\ArrayOfDCSCoupon
     */
    public function setDCSCoupon(array $dCSCoupon = array())
    {
        // validation for constraint: array
        if ('' !== ($dCSCouponArrayErrorMessage = self::validateDCSCouponForArrayConstraintsFromSetDCSCoupon($dCSCoupon))) {
            throw new \InvalidArgumentException($dCSCouponArrayErrorMessage, __LINE__);
        }
        if (is_null($dCSCoupon) || (is_array($dCSCoupon) && empty($dCSCoupon))) {
            unset($this->DCSCoupon);
        } else {
            $this->DCSCoupon = $dCSCoupon;
        }
        return $this;
    }
    /**
     * Add item to DCSCoupon value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\DCSCoupon $item
     * @return \App|C\ArrayType\ArrayOfDCSCoupon
     */
    public function addToDCSCoupon(\App|C\StructType\DCSCoupon $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\DCSCoupon) {
            throw new \InvalidArgumentException(sprintf('The DCSCoupon property can only contain items of type \App|C\StructType\DCSCoupon, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DCSCoupon[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\DCSCoupon|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\DCSCoupon|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\DCSCoupon|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\DCSCoupon|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\DCSCoupon|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DCSCoupon
     */
    public function getAttributeName()
    {
        return 'DCSCoupon';
    }
}
