<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfECouponAmount ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfECouponAmount
 * @subpackage Arrays
 */
class ArrayOfECouponAmount extends AbstractStructArrayBase
{
    /**
     * The ECouponAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ECouponAmount[]
     */
    public $ECouponAmount;
    /**
     * Constructor method for ArrayOfECouponAmount
     * @uses ArrayOfECouponAmount::setECouponAmount()
     * @param \App|C\StructType\ECouponAmount[] $eCouponAmount
     */
    public function __construct(array $eCouponAmount = array())
    {
        $this
            ->setECouponAmount($eCouponAmount);
    }
    /**
     * Get ECouponAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ECouponAmount[]|null
     */
    public function getECouponAmount()
    {
        return isset($this->ECouponAmount) ? $this->ECouponAmount : null;
    }
    /**
     * This method is responsible for validating the values passed to the setECouponAmount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setECouponAmount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateECouponAmountForArrayConstraintsFromSetECouponAmount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfECouponAmountECouponAmountItem) {
            // validation for constraint: itemType
            if (!$arrayOfECouponAmountECouponAmountItem instanceof \App|C\StructType\ECouponAmount) {
                $invalidValues[] = is_object($arrayOfECouponAmountECouponAmountItem) ? get_class($arrayOfECouponAmountECouponAmountItem) : sprintf('%s(%s)', gettype($arrayOfECouponAmountECouponAmountItem), var_export($arrayOfECouponAmountECouponAmountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ECouponAmount property can only contain items of type \App|C\StructType\ECouponAmount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ECouponAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ECouponAmount[] $eCouponAmount
     * @return \App|C\ArrayType\ArrayOfECouponAmount
     */
    public function setECouponAmount(array $eCouponAmount = array())
    {
        // validation for constraint: array
        if ('' !== ($eCouponAmountArrayErrorMessage = self::validateECouponAmountForArrayConstraintsFromSetECouponAmount($eCouponAmount))) {
            throw new \InvalidArgumentException($eCouponAmountArrayErrorMessage, __LINE__);
        }
        if (is_null($eCouponAmount) || (is_array($eCouponAmount) && empty($eCouponAmount))) {
            unset($this->ECouponAmount);
        } else {
            $this->ECouponAmount = $eCouponAmount;
        }
        return $this;
    }
    /**
     * Add item to ECouponAmount value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ECouponAmount $item
     * @return \App|C\ArrayType\ArrayOfECouponAmount
     */
    public function addToECouponAmount(\App|C\StructType\ECouponAmount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ECouponAmount) {
            throw new \InvalidArgumentException(sprintf('The ECouponAmount property can only contain items of type \App|C\StructType\ECouponAmount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ECouponAmount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ECouponAmount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ECouponAmount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ECouponAmount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ECouponAmount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ECouponAmount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ECouponAmount
     */
    public function getAttributeName()
    {
        return 'ECouponAmount';
    }
}
