<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfETTicketFare ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfETTicketFare
 * @subpackage Arrays
 */
class ArrayOfETTicketFare extends AbstractStructArrayBase
{
    /**
     * The ETTicketFare
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ETTicketFare[]
     */
    public $ETTicketFare;
    /**
     * Constructor method for ArrayOfETTicketFare
     * @uses ArrayOfETTicketFare::setETTicketFare()
     * @param \App|C\StructType\ETTicketFare[] $eTTicketFare
     */
    public function __construct(array $eTTicketFare = array())
    {
        $this
            ->setETTicketFare($eTTicketFare);
    }
    /**
     * Get ETTicketFare value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ETTicketFare[]|null
     */
    public function getETTicketFare()
    {
        return isset($this->ETTicketFare) ? $this->ETTicketFare : null;
    }
    /**
     * This method is responsible for validating the values passed to the setETTicketFare method
     * This method is willingly generated in order to preserve the one-line inline validation within the setETTicketFare method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateETTicketFareForArrayConstraintsFromSetETTicketFare(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfETTicketFareETTicketFareItem) {
            // validation for constraint: itemType
            if (!$arrayOfETTicketFareETTicketFareItem instanceof \App|C\StructType\ETTicketFare) {
                $invalidValues[] = is_object($arrayOfETTicketFareETTicketFareItem) ? get_class($arrayOfETTicketFareETTicketFareItem) : sprintf('%s(%s)', gettype($arrayOfETTicketFareETTicketFareItem), var_export($arrayOfETTicketFareETTicketFareItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ETTicketFare property can only contain items of type \App|C\StructType\ETTicketFare, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ETTicketFare value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETTicketFare[] $eTTicketFare
     * @return \App|C\ArrayType\ArrayOfETTicketFare
     */
    public function setETTicketFare(array $eTTicketFare = array())
    {
        // validation for constraint: array
        if ('' !== ($eTTicketFareArrayErrorMessage = self::validateETTicketFareForArrayConstraintsFromSetETTicketFare($eTTicketFare))) {
            throw new \InvalidArgumentException($eTTicketFareArrayErrorMessage, __LINE__);
        }
        if (is_null($eTTicketFare) || (is_array($eTTicketFare) && empty($eTTicketFare))) {
            unset($this->ETTicketFare);
        } else {
            $this->ETTicketFare = $eTTicketFare;
        }
        return $this;
    }
    /**
     * Add item to ETTicketFare value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETTicketFare $item
     * @return \App|C\ArrayType\ArrayOfETTicketFare
     */
    public function addToETTicketFare(\App|C\StructType\ETTicketFare $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ETTicketFare) {
            throw new \InvalidArgumentException(sprintf('The ETTicketFare property can only contain items of type \App|C\StructType\ETTicketFare, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ETTicketFare[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ETTicketFare|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ETTicketFare|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ETTicketFare|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ETTicketFare|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ETTicketFare|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ETTicketFare
     */
    public function getAttributeName()
    {
        return 'ETTicketFare';
    }
}
