<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SpecialServiceDataSeat StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SpecialServiceDataSeat
 * @subpackage Structs
 */
class SpecialServiceDataSeat extends ApiObject
{
    /**
     * The SeatLetter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SeatLetter;
    /**
     * The SeatRow
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $SeatRow;
    /**
     * Constructor method for SpecialServiceDataSeat
     * @uses SpecialServiceDataSeat::setSeatLetter()
     * @uses SpecialServiceDataSeat::setSeatRow()
     * @param string $seatLetter
     * @param int $seatRow
     */
    public function __construct($seatLetter = null, $seatRow = null)
    {
        $this
            ->setSeatLetter($seatLetter)
            ->setSeatRow($seatRow);
    }
    /**
     * Get SeatLetter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSeatLetter()
    {
        return isset($this->SeatLetter) ? $this->SeatLetter : null;
    }
    /**
     * Set SeatLetter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $seatLetter
     * @return \App|C\StructType\SpecialServiceDataSeat
     */
    public function setSeatLetter($seatLetter = null)
    {
        // validation for constraint: string
        if (!is_null($seatLetter) && !is_string($seatLetter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($seatLetter, true), gettype($seatLetter)), __LINE__);
        }
        if (is_null($seatLetter) || (is_array($seatLetter) && empty($seatLetter))) {
            unset($this->SeatLetter);
        } else {
            $this->SeatLetter = $seatLetter;
        }
        return $this;
    }
    /**
     * Get SeatRow value
     * @return int|null
     */
    public function getSeatRow()
    {
        return $this->SeatRow;
    }
    /**
     * Set SeatRow value
     * @param int $seatRow
     * @return \App|C\StructType\SpecialServiceDataSeat
     */
    public function setSeatRow($seatRow = null)
    {
        // validation for constraint: int
        if (!is_null($seatRow) && !(is_int($seatRow) || ctype_digit($seatRow))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($seatRow, true), gettype($seatRow)), __LINE__);
        }
        $this->SeatRow = $seatRow;
        return $this;
    }
}
